/*
	ILLUSION Type1 PAC Archive
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

unsigned char	*header_str = { "PACK" };

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned char	file_count;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			header_filename[13];
	char			out_filename[256];
	unsigned long	nowsize;

	int				i = 0;

	memset( out_filename, 0, sizeof( out_filename ));

	printf( "ILLUSION Type1 File Divider 070718 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: ILPDIV1 <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* header */
	buf = ( unsigned char * )calloc( 1, 0x08 );
	fseek( in, 0, SEEK_SET );
	fread( buf, 0x08, 1, in );

	if( memcmp( &buf[3], header_str, 4 ))
	{
		printf( "not PACK format.\n" );
		free( buf );
		return;
	}
	free( buf );

	/* file_count */
	file_count = buf[0x07];
	printf( "file_count: %u\n", file_count );

	/* read header */
	buf = ( unsigned char * )calloc( file_count, 0x10 );
	fread( buf, file_count * 0x10, 1, in );

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		memcpy( header_filename, &buf[i * 0x10], 8 );
		header_filest = *( unsigned int *)( buf + (( i * 0x10 ) + 0x0C ));
		header_filest <<= 16;
		header_filest += *( unsigned int *)( buf + (( i * 0x10 ) + 0x0E ));
		header_filesize = *( unsigned int *)( buf + (( i * 0x10 ) + 0x08 ));
		header_filesize <<= 16;
		header_filesize += *( unsigned int *)( buf + (( i * 0x10 ) + 0x0A ));
		header_fileed = header_filest + header_filesize;

		printf( "%04d : %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 3 )
		{
			sprintf( out_filename, "%s%s",
				av[2],
				header_filename
			);
		} else sprintf( out_filename, "%s", header_filename );

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	/* 32k */
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
