/*
	ILLUSION Type2 SEPAC Archive
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned char	file_count;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			header_filename[13];
	char			out_filename[256];
	unsigned long	nowsize;
	unsigned long	offset_plus;

	int				i = 0;

	memset( out_filename, 0, sizeof( out_filename ));

	printf( "ILLUSION Type2 File Divider 070718 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: ILPDIV2 <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* file_count */
	buf = ( unsigned char * )calloc( 1, 1 );

	fseek( in, 0, SEEK_SET );
	fread( buf, 0x01, 1, in );
	file_count = buf[0];
	printf( "file_count: %u\n", file_count );
	free( buf );

	/* read header */
	buf = ( unsigned char * )calloc( file_count, 0x02 );
	fread( buf, file_count * 0x02, 1, in );

	offset_plus = ftell( in );

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		sprintf( header_filename, "SE%02d", i );

		header_filest = *( unsigned int *)( buf + ( i * 2 ));
		header_filest += offset_plus;

		if( i == ( file_count - 1 ))
		{
			header_fileed = file_ed;
		} else {
			header_fileed = *( unsigned int *)( buf + (( i * 2 ) + 2 ));
			header_fileed += offset_plus;
		}

		header_filesize = header_fileed - header_filest;

		printf( "%04d : %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 3 )
		{
			sprintf( out_filename, "%s%s",
				av[2],
				header_filename
			);
		} else sprintf( out_filename, "%s", header_filename );

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	/* 32k */
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
